您的位置:首页 > 其它

HDU 1054 最小顶点覆盖 (树形dp)

2016-02-28 13:11 465 查看


Problem Description

Bob enjoys playing computer games, especially strategic games, but sometimes he cannot find the solution fast enough and then he is very sad. Now he has the following problem. He must defend a medieval city, the roads of which form a tree. He has to put the
minimum number of soldiers on the nodes so that they can observe all the edges. Can you help him?

Your program should find the minimum number of soldiers that Bob has to put for a given tree.

The input file contains several data sets in text format. Each data set represents a tree with the following description:

the number of nodes

the description of each node in the following format

node_identifier:(number_of_roads) node_identifier1 node_identifier2 ... node_identifier

or

node_identifier:(0)

The node identifiers are integer numbers between 0 and n-1, for n nodes (0 < n <= 1500). Every edge appears only once in the input data.

For example for the tree:



the solution is one soldier ( at the node 1).

The output should be printed on the standard output. For each given input data set, print one integer number in a single line that gives the result (the minimum number of soldiers). An example is given in the following table:


Sample Input

4
0:(1) 1
1:(2) 2 3
2:(0)
3:(0)
5
3:(3) 1 4 2
1:(1) 0
2:(0)
0:(0)
4:(0)



Sample Output

1
2


dp
[0],dp
[1] 表示两种状态,因为前一种状态会影响到后一种的状态,so就用这种来表示,完美。

dp
[0]表示该点不取,固之前的点必须去,dp
[0]+=dp[son
][1];

dp
[1]表示该点取,so之前的点可取可不取,那么我们就取代价最小的累加,dp
[1]+=min(dp[son[]n][1],dp[son
][0]);

此处贴一下代码...

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<queue>
#include<vector>
using namespace std;
const int N = 1500 + 100;
vector<int>vv
;
int fa
,dp
[2];
void dfs(int root)
{
int i,j,len=vv[root].size();
for(i=0;i<len;i++) {
dfs(vv[root][i]);
dp[root][0]+=dp[vv[root][i]][1];
dp[root][1]+=min(dp[vv[root][i]][0],dp[vv[root][i]][1]);
}
}
int main()
{
int n,i,j,root,m,u,v;
while(scanf("%d",&n)!=EOF) {
for(i=0;i<=n;i++) {
fa[i]=i;
dp[i][0]=0;
dp[i][1]=1;
vv[i].clear();
}
for(i=1;i<=n;i++) {
scanf("%d:(%d)",&root,&m);
while(m--) {
scanf("%d",&v);
vv[root].push_back(v);
fa[v]=root;
}
}
root=1;
while(fa[root]!=root) root=fa[root];
dfs(root);
printf("%d\n",min(dp[root][0],dp[root][1]));
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: